//     I_sakura
//     blossomW_P class: pink, white
//     astra_O class: orange, yellow, red, blue
//     Created by Severin Jelinek, Jan 26th, 2001 
//     1 Buffer, HTML, width, height,  f_leaves, triangles, info
//   ================================

import java.awt.*;
import java.applet.*;

//  separate blossomW_P class

class blossomW_P
{
		//instance variables
	int  diameter, num, r, x, y;
	int h, w;
	double alpha, beta, r_N;
	Graphics g;

		//constructor
	public blossomW_P (int diameter, int h, int w)
	{
		this.diameter=diameter;
		this.h=h;	
		this.w=w;
	}

		//   random number 
	public void r_N ()
	{
		r_N =  Math.random() ;
	}

	public void drawRandomBlossom (int diameter, int x, int y) 
	{
			//   smaller pink blossoms than astras
		diameter = diameter/2;

			// white color & 15 shades of pink
		r_N ();
		r_N = r_N * r_N;
		int white_level = (int)(r_N * 16)
 * 8 + 127;
		Color randomColor = new Color(255, white_level, white_level);

		r_N ();
		r_N = r_N * r_N;
		r = (int)diameter/2;
		x =  (int)(r_N * w + r);
		r_N ();
		r_N = r_N * r_N;
		y =  (int)(r_N * h * 2/3 + r);

//     r * 0     r * 1     		  | 
//     r * 0.9511     r * 0.3090     .-i
//     r * 0.5878     r * 0.8090     \

		num = 5;
		r_N ();
		alpha = r_N * Math.PI * 2;

//   xxxxxxxxx
//   x - r, y - r
//   for all angles:
//   x - r + (int)(r * Math.cos(alpha + beta))
//   y - r - (int)(r * Math.sin(alpha + beta))

		g.setColor(randomColor);

		for (int i=0; i<num; i++)
		{
			beta = Math.PI * 2 * i /num;
			g.fillOval(x - r + (int)(r * Math.cos(alpha + beta)), y - r - (int)(r * Math.sin(alpha + beta)), diameter, diameter);
		}

		g.setColor(Color.yellow);
			// new r
		r = (int)(diameter/4);
		g.fillOval(x - r, y - r, 2 * r, 2 * r);
	}

	public void paint(Graphics gr)
	{
		g=gr;
		drawRandomBlossom (diameter, x, y);
	}
}





//  separate astra_O class

class astra_O
{
		//instance variables
	int  diameter, f_leaves, num, r, x, y;
	int h, w;
	double alpha, beta, r_N;
	Graphics g;
	int green;
	int red = 255;
	int blue = 255;

		//constructor
	public astra_O (int diameter, int h, int w, int f_leaves)
	{
		this.diameter=diameter;
		this.h=h;	
		this.w=w;
		this.f_leaves = f_leaves;
	}

		//   random number 
	public void r_N ()
	{
		r_N =  Math.random() ;
	}

		//   random number from 0 through n
	static int r_N2 (int n)
	{
		return  (int)(Math.random() * (n + 1)) ;
	}

//   =========

	public void drawRandomBlossom (int diameter, int x, int y, int f_leaves) 
	{

			// orange color between yellow and red
		r_N ();
		green = r_N2 (8) * 32;
		if (green == 256) green = 255;
			//   pale blue color, 10%
		if (r_N2(9) == 1)
			{
				green = 127;
				Color randomColor = new Color(127, green, blue);
				g.setColor(randomColor);
			} else
			{
				Color randomColor = new Color(255, green, 0);
				g.setColor(randomColor);
			}

		r_N ();
		r_N = r_N;
		x =  (int)(r_N * w);
		r_N ();
		r_N = r_N * r_N;
		y =  (int)(h - r_N * h / 3);

			//   quadruple number : leaf & space
		num = 4 * (f_leaves + r_N2 (4));
		r_N ();
		alpha = r_N * Math.PI * 2;
		r = (int)(diameter * (1 + r_N2 (4) * 0.1));

	//   xxxxxxxxx triangels
//   x, y no shift
//   for all angles
//   x = (int)(r * Math.cos(alpha + beta))
//   y = - (int)(r * Math.sin(alpha + beta))

		int [] xp = new int [3];
		int [] yp = new int [3];

		beta = Math.PI * 2  / num;

		for (int i=0; i<num; i+=4)
		{
			xp[0] = x;
			yp[0] = y;
			xp[1] = x + (int)(r * Math.cos(alpha + i * beta));
			yp[1] = y - (int)(r * Math.sin(alpha + i * beta));
			xp[2] = x + (int)(r * Math.cos(alpha + (i + 3) * beta));
			yp[2] = y - (int)(r * Math.sin(alpha + (i + 3) * beta));
			g.fillPolygon(xp,yp,3);
		}

		g.setColor(Color.yellow);
			// new r
		r = (int)diameter/4;

		g.fillOval(x - r, y - r, 2 * r, 2 * r);
	}

	public void paint(Graphics gr)
	{
		g=gr;
		drawRandomBlossom (diameter, x, y, f_leaves);
	}
	String xyz = "     Severin Jelinek, 1_0126     ";
}


//------------------------------------------



public class I_sakura extends Applet implements Runnable 
{
	Thread anim;
	private Image Buffer;
    	private Graphics gBuffer;
	String txt;
	String flower;

	int h, w;
	blossomW_P myBlossom;
	astra_O myAstra;
	int diameter = 12;
	int count, delay = 3;
	int  f_number = 30, f_leaves = 6;

	public void init () 
	{
		w = size().width;
		h = size().height;
		Buffer=createImage(w, h);
        	gBuffer=Buffer.getGraphics();

			// parameters from HTML
		txt=getParameter("text_1");
		String str1 = getParameter( "flower_number");
		if (str1 != null)
			f_number = Integer.parseInt(str1, 10);
		if (f_number < 1) f_number = 1;
		flower = getParameter("flower_size");
		if (flower != null)
			diameter = Integer.parseInt(flower, 10);
		if (diameter < 4) diameter  = 4;
		String str2 = getParameter( "flower_leaves");
		if (str2 != null)
		f_leaves = Integer.parseInt(str2, 10);
		if (f_leaves < 3) f_leaves = 3;
	}


//****************
//+++++++++++++++++

	public void paint (Graphics g)
	{
			//   paint the background dark green
			//   with delay & after f_number
		count++;
		if (count > f_number + delay)
			count = 0;

		if (count == 1) {
			gBuffer.setColor(Color.red);
			gBuffer.fillRect(0,0,w, h);
			Color myGreen = new Color(0, 191, 0);
			gBuffer.setColor(myGreen);
			gBuffer.fillRect(10, 5 ,w - 10, h - 5);
			int a = (int) h/6;
			gBuffer.setColor(Color.yellow);
			gBuffer.fillOval(a, a, 2 * a, 2 * a);
		}

		if (count > delay) {
			for (int i=0; i<4; i++)
			{
				myBlossom = new blossomW_P (diameter, h, w);
				myBlossom .paint (gBuffer);
			}
			myAstra = new astra_O (diameter, h, w, f_leaves);
			myAstra.paint (gBuffer);
		}

//%%%%%%%

		int ht = (int) h * 2/3;
		int wt = (int) w * 1/10;
		int st = (int) h * 1/10;
		if (st > 20) st = 20;
                gBuffer.setColor(Color.red);
		gBuffer.setFont(new Font("Courier", Font.BOLD, st));		if (txt.substring(0, 1).equals ("*")) {
                gBuffer.drawString(f_number + "  " + diameter + "  " + f_leaves + "  " + txt.substring(1,  txt.length ()),  wt, ht);
		}
		else {
                gBuffer.drawString(txt, wt, ht);
		}

		g.drawImage (Buffer,0,0, this);
	}

// +++++++++++++  run, update, start, stop, destroy

		//   halt the thread for 1 second
	public void run() { while(true) { try {anim.sleep (1000); } catch (Exception e) { } repaint(); } }
	public void update(Graphics g) { paint(g); }
	public void start()	{ if (anim == null) { anim = new Thread (this); anim.start(); } }
	public void stop() { if (anim != null) {  anim.stop();anim = null; } }
	public void destroy() { anim = null; }
	String xyz = "     Severin Jelinek, 1_0126     ";
}


